use `ombutel`;

create table `ombu_cloudphone_profiles` (
  `profile_id` int(10) unsigned not null,
  `host` varchar(255) collate utf8_unicode_ci not null,
  `peertype` enum('friend','peer','user') collate utf8_unicode_ci not null,
  `qualify` int(10) unsigned not null,
  `qualifyfreq` int(10) unsigned not null,
  `transport` varchar(255) collate utf8_unicode_ci not null,
  `icesupport` enum('yes','no') collate utf8_unicode_ci not null,
  `encryption` enum('yes','no') collate utf8_unicode_ci not null,
  `avpf` enum('yes','no') collate utf8_unicode_ci not null,
  `directmedia` enum('yes','no','nonat','update') collate utf8_unicode_ci not null,
  `sendrpid` enum('yes','no','rpid','pai') collate utf8_unicode_ci not null,
  `trustrpid` enum('yes','no') collate utf8_unicode_ci not null,
  `codecs` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `deny` varchar(255) COLLATE utf8_unicode_ci DEFAULT '0.0.0.0/0',
  `permit` varchar(255) COLLATE utf8_unicode_ci DEFAULT '0.0.0.0/0',
  `dtmfmode` enum('rfc2833','info','shortinfo','inband','auto') COLLATE utf8_unicode_ci DEFAULT 'rfc2833',
  `nat` enum('no','force_rport','comedia','auto_force_rport','auto_comedia','force_rport,comedia') COLLATE utf8_unicode_ci NOT NULL,
  primary key (`profile_id`),
  foreign key (`profile_id`) references `ombu_device_profiles` (`profile_id`) on delete cascade
);

insert into `ombu_device_profiles` (`technology`, `name`, `description`, `default`) values
	('cloudphone', 'Default Cloudphone Profile', 'Default Cloudphone Profile', 'yes');
select `profile_id` from `ombu_device_profiles` where `name` = 'Default Cloudphone Profile' into @cloudphone_profile_id;

insert ignore into `ombu_cloudphone_profiles` (`profile_id`, `host`, `peertype`, `qualify`, `qualifyfreq`, `transport`, `icesupport`, `encryption`, `avpf`, `directmedia`, `sendrpid`, `trustrpid`, `codecs`, `deny`, `permit`, `dtmfmode`, `nat`) values
(@cloudphone_profile_id, 'dynamic', 'friend', 2000, 60, 'udp', 'no', 'no', 'no', 'nonat', 'yes', 'yes', 'g729', '0.0.0.0/0', '0.0.0.0/0', 'rfc2833', 'no');
