insert ignore into `ombutel`.`ombu_device_profiles` (
	`technology`,
	`name`,
	`description`,
	`default`
) select
	'sip',
	'SIP Trunk Profile',
	'SIP Trunk Profile',
	'no'
from `ombutel`.`ombu_sip_trunks` st
left join `ombutel`.`ombu_device_profiles` dp using (`profile_id`)
where dp.`default` = 'yes' and dp.`technology` = 'sip'
limit 1;

insert ignore into `ombutel`.`ombu_sip_profiles` (
	`profile_id`,
	`host`,
	`peertype`,
	`qualify`,
	`qualifyfreq`,
	`transport`,
	`icesupport`,
	`encryption`,
	`avpf`,
	`directmedia`,
	`sendrpid`,
	`trustrpid`,
	`codecs`,
	`videosupport`,
	`maxcallbitrate`,
	`preferred_codec_only`,
	`autoframing`
) select
	dp2.`profile_id`,
	sp.`host`,
	sp.`peertype`,
	sp.`qualify`,
	sp.`qualifyfreq`,
	sp.`transport`,
	sp.`icesupport`,
	sp.`encryption`,
	sp.`avpf`,
	sp.`directmedia`,
	'no',
	sp.`trustrpid`,
	sp.`codecs`,
	sp.`videosupport`,
	sp.`maxcallbitrate`,
	sp.`preferred_codec_only`,
	sp.`autoframing`
from `ombutel`.`ombu_device_profiles` dp1
left join `ombutel`.`ombu_device_profiles` dp2 on
	(dp2.`name` = 'SIP Trunk Profile')
left join `ombutel`.`ombu_sip_profiles` sp on
	(sp.`profile_id` = dp1.`profile_id`)
where dp1.`default` = 'yes' and dp1.`technology` = 'sip';

update `ombutel`.`ombu_sip_trunks` st
left join `ombutel`.`ombu_device_profiles` dp1 on
	(dp1.`profile_id` = st.`profile_id`)
left join `ombutel`.`ombu_device_profiles` dp2 on
	(dp2.`technology` = 'sip' and dp2.`name` = 'SIP Trunk Profile')
set st.`profile_id` = dp2.`profile_id`
where dp1.`default` = 'yes'
	and dp1.`technology` = 'sip'
	and dp2.`profile_id` is not null;
