(function () {
	var tree = $('.tree');
	$("#users_profiles_form").validate(Validations);
	var allCheckboxes = $('input[type="checkbox"]');
	tree.treegrid({ initialState: 'collapsed' });
	var superadmin = $("#users_profiles_form").find('#superadmin').val();

	// grand all privilages
	$('#superadmin').on('change', function () {
		var state = $(this).prop('checked');
		$('input[type=checkbox]').prop('checked', state).removeClass('partial');
	});

	// collapse/expand menus
	$("button.up_collapse_all, button.up_expand_all").click(function() {
		$('i#up_expand_spinner').addClass('active'); //Show spinner
		var action = 'collapseAll';
		if($(this).hasClass('up_expand_all')) {
			action = 'expandAll';
		}
		$.ajax({
			data: { delay:1 },
			success: function () {
				tree.treegrid(action);
			}
		}).always(function(){
			$('i#up_expand_spinner').removeClass('active');
		});
	});

	load();

	allCheckboxes.on('change', function() {
		var checked = $(this).is(':checked');
		var current_level = $(this).data('level');

		var disabled_module_id = $("#users_profiles_form").find("#disabled_module_id").val();
		var level = get_max_menu_level();
		if(current_level) { // clicked menu or module
			$(this).removeClass('partial');
			if(current_level > level) { // module
				//bubble down
				var module_id = $(this).data('module_id');
				if(superadmin != 1 || module_id != disabled_module_id) {
					$('.priv_' + module_id).prop('checked', checked);
				}
				bubble_up(this, current_level);
			} else { //menu
				//bubble down
				var menu_id = $(this).data('l' + current_level);
				var index = current_level;
				while(index < level + 1) {
					index++;
					children = $('[data-l'+current_level+'='+menu_id+'][data-level='+ index +']');
					$(children).removeClass('partial');
					if(index == (level + 1)) {
						$(children).each(function() {
							var module_id = $(this).data('module_id');
							if(superadmin != 1 || module_id != disabled_module_id) {
								$(this).prop('checked', checked);
							}
						});
					} else {
						$(children).prop('checked', checked);
					}
					if(index == (level + 1)) { // set priveleges
						children.each(function() {
							var module_id = $(this).data('module_id');
							if(superadmin != 1 || module_id != disabled_module_id) {
								var privileges = $('.priv_' + module_id);
								$(privileges).prop('checked', checked);
							}
						});
					}
				}
				bubble_up(this, current_level);
			}
		} else { // clicked privilage
			set_parent_module($(this));
			var module_id = $(this).data('module_id');
			var parent = $('.modules.checkbox_' + module_id); // module
			bubble_up(parent, level + 1)
		}
	});
})();

function bubble_up(parent, level) {
	while(level > 1) {
		index = level - 1;
		var menu_id = $(parent).data('l'+index);
		var parent_menu = $('.menu'+index+'.checkbox_' + menu_id); // parent menu
		chks = $('[data-l'+index+'='+menu_id+'][data-level='+ level +']').length;
		chksChecked = $('[data-l'+index+'='+menu_id+'][data-level='+ level +']:checked').length;
		partial_checked = $('[data-l'+index+'='+menu_id+'][data-level='+ level +'].partial').length;
		$(parent_menu).prop('checked', (chks == chksChecked));
		(partial_checked || (chks > chksChecked && chksChecked)) ?
			$(parent_menu).addClass('partial') :
			$(parent_menu).removeClass('partial');
		level--;
	}
}

function load() {
	$('.modules').each(function() {
		var module_id = $(this).data('module_id');
		chks = $('.priv_' + module_id).length;
		chksChecked = $('.priv_' + module_id + ':checked').length;
		set_module_checkbox($(this), chks, chksChecked);
	});

	var level = get_max_menu_level();
	while(level) {
		$('.menu' + level).each(function() {
			var menu_id = $(this).data('l' + level);
			chks = $('[data-l'+level+'='+menu_id+'][data-level='+ (level+1) +']').length;
			chksChecked = $('[data-l'+level+'='+menu_id+'][data-level='+ (level+1) +']:checked').length;
			partial_checked = $('[data-l'+level+'='+menu_id+'][data-level='+ (level+1) +'].partial').length;
			$(this).prop('checked', (chks == chksChecked));
			(partial_checked || (chks > chksChecked && chksChecked)) ? $(this).addClass('partial') : $(this).removeClass('partial');
		});
		level--;
	}
}

function set_parent_module(item) {
	var module_id = item.data('module_id');
	var parent = $('.modules.checkbox_' + module_id);
	chks = $('.priv_' + module_id).length;
	chksChecked = $('.priv_' + module_id + ':checked').length;
	set_module_checkbox($(parent), chks, chksChecked);
}

function set_module_checkbox(parent, items, items_checked) {
	parent.removeClass('partial');
	if(items_checked == 0) {
		parent.prop('checked', false);
	} else if(items_checked == items) {
		parent.prop('checked', true);
	} else {
		parent.addClass('partial');
	}
}

function get_max_menu_level() {
	var level = parseInt($("#users_profiles_form").find("#max_menu_level").val())
	return isNaN(level) ? 2 : level; // set default=2. Should never happen
}
